# Set pricing option for dynamic products

## Overview

Use the **Product** object option property in order to define pricing options for dynamic products.

## Use case

1. Add an HTML link or button in your page like the one below.
2. Create a JavaScript click handler to execute the Inline Client desired methods.
3. Set the dynamic mode for cart by calling`TwoCoInlineCart.setup.setMode('DYNAMIC')`.
4. Set your currency using the`TwoCoInlineCart.cart.setCurrency('USD')`method.
5. Use the`TwoCoInlineCart.products.add({name, quantity, price, options})`method to prepare your dynamic products.
6. The **options** property should contain a list of objects with the name of the field, it's value and surcharge.
7. You can see below a signature token request payload for this example. A success response contains a JSON with the property  “signature“ which needs to be used at the next step to set the signature using the TwoCoInlineCart method.<br>

   ```javascript
   {
       "merchant": "2COLRNC",
       "dynamic": "1",
       "currency": "USD",
       "products": [
           {
               "name": "A test dynamic product",
               "quantity": 1,
               "price": 20,
               "options": [
                   {
                       "name": "color",
                       "value": "red",
                       "surcharge": 10
                   },
                   {
                       "name": "shape",
                       "value": "squared",
                       "surcharge": 20
                   }
               ]
           }
       ]
   }
   ```

   \
   The above payload will generate the signature 50a651873d3d8926f6bb62397f34b1ec7dd3373fc885b28466db8f4022060138.
8. Use the TwoCoInlineCart.cart.setSignature('50a651873d3d8926f6bb62397f34b1ec7dd3373fc885b28466db8f4022060138') method to set the signature. It is important that you employ TwoCoInlineCart.cart.removeAll() just before the TwoCoInlineCart.products.addMany(products) or TwoCoInlineCart.products.add(product) methods to remove previous products as the signature is based on the products' definition.
9. Use the`TwoCoInlineCart.cart.checkout()`method to show the cart on your page.

## Sample request

### HTML

```html
<a href="#" class="btn btn-success" id="buy-button">Buy now!</a>
```

### JavaScript

```javascript
window.document.getElementById('buy-button').addEventListener('click', function() {
  TwoCoInlineCart.setup.setMode('DYNAMIC');
  TwoCoInlineCart.cart.setCurrency('USD');

  TwoCoInlineCart.products.add({
    name: 'A test dynamic product',
    quantity: 1,
    price: 20,
    options: [\
      {\
        name     : 'color',\
        value    : 'red',\
        surcharge: 10\
      },\
      {\
        name     : 'shape',\
        value    : 'squared',\
        surcharge: 20\
      }\
    ],
  });

  TwoCoInlineCart.cart.setSignature('50a651873d3d8926f6bb62397f34b1ec7dd3373fc885b28466db8f4022060138');
  TwoCoInlineCart.cart.checkout();
});
```

## Demo

After setting the pricing options for dynamic products using the above method, your cart should look like this.

{% embed url="<https://codepen.io/2checkout-documentation/pen/QXjVqr>" %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.2checkout.com/shopping-carts/inline/use-cases/set-pricing-option-for-dynamic-products.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
